//---------------------------------------------------------
#include "stdafx.h"

char * g_szTitleModelMerge = "ModelMerge";

COptionsModelMerge :: COptionsModelMerge() {	//TODO-Set Default Values
	m_iModel1=0;
	m_iChannels1=0;
	m_bModel2=false;
	m_iModel2=0;
	m_iChannels2=0;
	}
bool COptionsModelMerge :: RegistryLoad() {
	return true;	//todo
	}
bool COptionsModelMerge :: RegistrySave() {
	return true;	//todo
	}
void COptionsModelMerge :: ToBuffer( BYTE * buf ) {
	//todo
	}
void COptionsModelMerge :: FromBuffer( BYTE * buf ) {
	//todo
	}

class CVwModelMerge : public CDialog { 
	private :
		CDlgCombo m_cmbModel1;
		CDlgEdit m_edtChannels1;
		CDlgCheck m_chkModel2;
		CDlgCombo m_cmbModel2;
		CDlgEdit m_edtChannels2;
		CDlgButton m_btnMerge;

		CStringArray m_acModelNames;
		CPtrArray m_ahwndModelWindows;
		
	public :
		COptionsModelMerge * m_pOptions;

		CVwModelMerge( ) {
			m_iID=IDD_MODELMERGE;
			}
		~CVwModelMerge(){
			}

		//-- Initialize controls
		void InitializeControls( ) {
			m_cmbModel1.SetHandle( GetDlgItem(m_hDlg, IDC_CMB_MODEL1), "Select Model To Merge");
			FillModelCombo( &m_cmbModel1 );

			m_edtChannels1.SetHandle( GetDlgItem(m_hDlg, IDC_EDT_CHANNELS1), "Number of Ion channels in patch of selected model");

			m_chkModel2.SetHandle( GetDlgItem(m_hDlg, IDC_CHK_MODEL2), "Combine with a 2nd model");

			m_cmbModel2.SetHandle( GetDlgItem(m_hDlg, IDC_CMB_MODEL2), "Select 2nd model to merge with");
			FillModelCombo( &m_cmbModel2, &m_acModelNames, &m_ahwndModelWindows );

			m_edtChannels2.SetHandle( GetDlgItem(m_hDlg, IDC_EDT_CHANNELS2), "Number of Ion channels in patch of selected model");

			m_btnMerge.SetHandle( GetDlgItem(m_hDlg, IDC_BTN_MERGE), "Execute merge");
			}
			
		//-- Set Control Values
		void SetControlValues( ) {
			m_cmbModel1.SetCurSel( m_pOptions->m_iModel1 );
			m_edtChannels1.SetTextInt( m_pOptions->m_iChannels1 );
			m_chkModel2.SetCheck( m_pOptions->m_bModel2 );
			m_cmbModel2.SetCurSel( m_pOptions->m_iModel2 );
			m_edtChannels2.SetTextInt( m_pOptions->m_iChannels2 );
			}
			
		//-- Get Control Values
		bool GetControlValues( ) {
			m_pOptions->m_iModel1=m_cmbModel1.GetCurSel();
			m_cmbModel1.GetText( m_pOptions->m_iModel1, &m_pOptions->m_cModel1 );
			m_pOptions->m_iChannels1=m_edtChannels1.GetTextInt();
			m_pOptions->m_bModel2=m_chkModel2.GetCheck();
			m_pOptions->m_iModel2=m_cmbModel2.GetCurSel();
			m_cmbModel2.GetText( m_pOptions->m_iModel2, &m_pOptions->m_cModel2 );
			m_pOptions->m_iChannels2=m_edtChannels2.GetTextInt();
			if( m_pOptions->m_iChannels1<=0 || ( m_pOptions->m_iChannels2<=0 && m_pOptions->m_bModel2 )  ) { 
				MessageBox( m_hDlg, "Channel count must be 1 or greater", "Model Merge", MB_OK);
				return false;
				}
			if( m_pOptions->m_iChannels1==1 && ! m_pOptions->m_bModel2 ) { 
				MessageBox( m_hDlg, "Nothing to merge", "Model Merge", MB_OK);
				return false;
				}
			return true;
			}
		//-- Button event handlers
		void OnOpenModel1( ) {	// Combo drop down
			//FillModelCombo( &m_cmbModel1 );
			}
		void OnChangeModel1( ) {	// combo selection change
			//TODO
			}
		void OnChangeChannels1( ) {	// edit contents changed
			//TODO
			}
		void OnCheckModel2( ) {	// checkbox toggled
			//TODO
			}
		void OnOpenModel2( ) {	// Combo drop down
			//FillModelCombo( &m_cmbModel2 );
			//TODO
			}
		void OnChangeModel2( ) {	// combo selection change
			//TODO
			}
		void OnChangeChannels2( ) {	// edit contents changed
			//TODO
			}
		void OnBtnMerge( ) {	// button presses 
			if( GetControlValues() ) { 
				//-- Model Merge
				//TODO - get refenced models, contruct 		// m_acModelNames;

				if( m_pOptions->m_iChannels1>0 && m_pOptions->m_iChannels2>0 && m_pOptions->m_iModel1>=0 && m_pOptions->m_iModel2>=0 ) {
					CModel * pModel1 = (CModel *)( ((CDialog *) GetWindowLong(GetParent((HWND)m_ahwndModelWindows[m_pOptions->m_iModel1]),0) )->GetData( 2, NULL ));
					CModel * pModel2 = (CModel *)( ((CDialog *) GetWindowLong(GetParent((HWND)m_ahwndModelWindows[m_pOptions->m_iModel2]),0) )->GetData( 2, NULL ));
					CModel oMrgMdl( pModel1, m_pOptions->m_bModel2 ? pModel2 : NULL, 
						m_pOptions->m_iChannels1, 
						m_pOptions->m_bModel2 ? m_pOptions->m_iChannels2 : 1 );
					SendMessage( OpenModelView( "Merged Model" ), WM_MODEL_SETMODEL, 0, (LPARAM)&oMrgMdl );
					}
				
				//-- Close dialog 
				EndDialog( m_hDlg, IDOK );
				}
			}
		void OnBtnCancel( ) {	// button presses 
			EndDialog( m_hDlg, IDCANCEL );
			}
	};

//-----------------------------------------------------------------------------
CVwModelMerge * g_pVwModelMerge;		// Modal - one and only instance

//-----------------------------------------------------------------------------
// Message Pump
BOOL CALLBACK VwModelMergeDlgProc( HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam) {
	int wmId, wmEvent;
	switch( iMsg ) {
		//----- DIALOG INIT -  Control Initialization
		case WM_INITDIALOG :
			g_pVwModelMerge->m_hDlg=hDlg;
			g_pVwModelMerge->InitializeControls();
			g_pVwModelMerge->SetControlValues();
			return TRUE;

		//----- MENU and CONTROL Commands
		case WM_COMMAND :
			wmId    = LOWORD(wParam);
			wmEvent = HIWORD(wParam);
			if( wmId == IDC_BTN_MERGE )
				g_pVwModelMerge->OnBtnMerge( );
			if( wmId == IDCANCEL )
				g_pVwModelMerge->OnBtnCancel( );
			return TRUE;

		case WM_PAINT : {
			PAINTSTRUCT ps;
			HDC hdc = BeginPaint(hDlg, &ps);
			//----- TODO - extra drawing here 
			EndPaint(hDlg, &ps);
			}
			return false;

		case WM_DESTROY :
			delete g_pVwModelMerge;
			WindowListRemove( hDlg );
			return TRUE;

		default :
			break;
		}
	return FALSE;
	}

//-----------------------------------------------------------------------------
void OpenVwModelMerge( HWND hDlg ) {
	//-- create dialogue and options
	COptionsModelMerge oOpt;
	#ifdef _DEBUG
		oOpt.m_iChannels1=1;
		oOpt.m_iChannels2=1;
		oOpt.m_iModel1=0;
		oOpt.m_iModel2=1;
		oOpt.m_bModel2=true;
	#endif
	oOpt.RegistryLoad();

	g_pVwModelMerge = new CVwModelMerge;
	g_pVwModelMerge->m_pOptions = &oOpt;

	//-- present dialogue, execute if [OK]
	if( DialogBox( GetInstance(), (LPCTSTR)IDD_MODELMERGE, hDlg, (DLGPROC)VwModelMergeDlgProc ) == IDOK ) {
		oOpt.RegistrySave();
	
		}
	}

